#include "ConvolvedCubeMapRenderTechnique.h"


ConvolvedCubeMapRenderTechnique::ConvolvedCubeMapRenderTechnique(unsigned long startFrame,
												unsigned long cubeMapUpdateInterval,
												unsigned int cubeMapResolution,												
												unsigned int reducedCubeMapResolution,
												bool useDistCalc,
												bool useFaceAngleCalc,
												float distTolerance,
												float angleTolerance,
												bool updateAllFace,
												ElementaryRenderable* parentRenderable,
												TechniqueGroup* parentTechniqueGroup)
							:RenderTechnique( parentRenderable, parentTechniqueGroup)
{
	this->cubeMapUpdateInterval = cubeMapUpdateInterval;
	this->cubeMapResolution = cubeMapResolution;
	this->reducedCubeMapResolution = reducedCubeMapResolution;
	this->useDistCalc = useDistCalc;
	this->useFaceAngleCalc = useFaceAngleCalc;
	this->distTolerance = distTolerance;
	this->angleTolerance = angleTolerance;
	this->startFrame = startFrame;
	this->updateAllFace = updateAllFace;
}

ConvolvedCubeMapRenderTechnique::~ConvolvedCubeMapRenderTechnique()
{

}

void ConvolvedCubeMapRenderTechnique::runChanged(RenderingRunType runType, RenderingRun* run)
{
	if(runType == ILLUMRUN_COLOR_CUBEMAP)
	{
		colorCubeMapRunChanged(run);
		return;
	}	
	if(runType == ILLUMRUN_REDUCED_CUBEMAP)
	{
		reducedCubeMapRunChanged(run);
		return;
	}
}

 void ConvolvedCubeMapRenderTechnique::update(unsigned long frameNum)
{	
		sharedRuns->updateRun(ILLUMRUN_COLOR_CUBEMAP, frameNum);	
		sharedRuns->updateRun(ILLUMRUN_REDUCED_CUBEMAP, frameNum);	
}
