#include "CubeMapRenderTechnique.h"


CubeMapRenderTechnique::CubeMapRenderTechnique(unsigned long startFrame,
												unsigned long cubeMapUpdateInterval,
												unsigned int cubeMapResolution,
												bool useDistCalc,
												bool useFaceAngleCalc,
												float distTolerance,
												float angleTolerance,
												bool updateAllFace,
												ElementaryRenderable* parentRenderable,
												TechniqueGroup* parentTechniqueGroup)
							:RenderTechnique( parentRenderable, parentTechniqueGroup)
{
	this->useDistCalc = useDistCalc;
	this->useFaceAngleCalc = useFaceAngleCalc;
	this->distTolerance = distTolerance;
	this->angleTolerance = angleTolerance;	
	this->cubeMapUpdateInterval = cubeMapUpdateInterval;
	this->cubeMapResolution = cubeMapResolution;
	this->startFrame = startFrame;
	this->updateAllFace = updateAllFace;	
}

CubeMapRenderTechnique::~CubeMapRenderTechnique()
{

}

void CubeMapRenderTechnique::runChanged(RenderingRunType runType, RenderingRun* run)
{
	if(runType == ILLUMRUN_COLOR_CUBEMAP)
		colorCubeMapRunChanged(run);
}

 void CubeMapRenderTechnique::update(unsigned long frameNum)
{	
		sharedRuns->updateRun(ILLUMRUN_COLOR_CUBEMAP, frameNum);	
}
