#include "DistanceCubeMapRenderTechnique.h"


DistanceCubeMapRenderTechnique::DistanceCubeMapRenderTechnique(unsigned long startFrame,
												unsigned long cubeMapUpdateInterval,
												unsigned int cubeMapResolution,												
												bool useDistCalc,
												bool useFaceAngleCalc,
												float distTolerance,
												float angleTolerance,
												bool updateAllFace,
												ElementaryRenderable* parentRenderable,
												TechniqueGroup* parentTechniqueGroup)
							:RenderTechnique( parentRenderable, parentTechniqueGroup)
{
	this->useDistCalc = useDistCalc;
	this->useFaceAngleCalc = useFaceAngleCalc;
	this->distTolerance = distTolerance;
	this->angleTolerance = angleTolerance;

	this->cubeMapUpdateInterval = cubeMapUpdateInterval;
	this->cubeMapResolution = cubeMapResolution;
	this->startFrame = startFrame;
	this->updateAllFace = updateAllFace;
}

DistanceCubeMapRenderTechnique::~DistanceCubeMapRenderTechnique()
{

}

void DistanceCubeMapRenderTechnique::runChanged(RenderingRunType runType, RenderingRun* run)
{
	if(runType == ILLUMRUN_DISTANCE_CUBEMAP)
		distanceCubeMapRunChanged(run);
}

void DistanceCubeMapRenderTechnique::runUpdated(RenderingRunType runType, RenderingRun* run)
{
	if(runType == ILLUMRUN_DISTANCE_CUBEMAP)
		distanceCubeMapRunUpdated(run);
}

 void DistanceCubeMapRenderTechnique::update(unsigned long frameNum)
{	
	sharedRuns->updateRun(ILLUMRUN_DISTANCE_CUBEMAP, frameNum);	
}
