#include "DistanceCubeMapRenderingRun.h"



DistanceCubeMapRenderingRun::DistanceCubeMapRenderingRun(unsigned long startFrame,
														unsigned long updateInterval,
														unsigned int resolution,
														   bool useDistCalc,
														   bool useFaceAngleCalc,
														   float distTolerance,
														   float angleTolerance,
														   bool updateAllFace)
														   :RenderingRun(startFrame, updateInterval)
{
	this->useDistCalc = useDistCalc;
	this->useFaceAngleCalc = useFaceAngleCalc;
	this->distTolerance = distTolerance;
	this->angleTolerance = angleTolerance;
	this->resolution = resolution;
	this->updateAllFace = updateAllFace;

	currentFace = 0;
}

void DistanceCubeMapRenderingRun::updateFrame(unsigned long frameNum)
{
	if(updateAllFace)
	{
		for(int i=0;i<6;i++)
		{
			updateCubeFace(i);
		}
	}
	else
	{
		if(lastupdated == -1 && updateInterval == 0)
		{
			for(int i=0;i<6;i++)
			{
				updateCubeFace(i);
			}
		}
		else
		{
			if(faceNeedsUpdate(currentFace))
				updateCubeFace(currentFace);

			currentFace = (currentFace + 1) % 6;
		}
	}
}
