#include "..\include\sharedruns.h"
#include "TechniqueGroup.h"

SharedRuns::SharedRuns(void)
{	
	child1 = 0;
	child2 = 0;
	parent = 0;

	childTechniques = 0;
}


SharedRuns* SharedRuns::getRoot()
{
	if(parent != 0)return parent->getRoot();
	return this;
}

SharedRuns* SharedRuns::getRoot(RenderingRunType runType)
{
	if(parent != 0)
		if(parent->hasOwnRun(runType))
			return parent->getRoot(runType);
	
	if(hasOwnRun(runType))
		return this;

	return 0;
}

SharedRuns* SharedRuns::joinRuns(SharedRuns* otherRuns)
{
	SharedRuns* result = createInstance();
	parent = result;
	otherRuns->parent = result;
	result->child1 = this;
	result->child2 = otherRuns;

	result->gatherRuns();
	result->fireRunChanges();
	result->updateBounds();

	return result;
}

void SharedRuns::runChanged(RenderingRunType runType, RenderingRun* run)
{
	if(child1 != 0) child1->runChanged(runType, run);
	if(child2 != 0) child2->runChanged(runType, run);
	if(childTechniques != 0) childTechniques->runChanged(runType, run);
}

void SharedRuns::runUpdated(RenderingRunType runType, RenderingRun* run)
{
	if(child1 != 0) child1->runUpdated(runType, run);
	if(child2 != 0) child2->runUpdated(runType, run);
	if(childTechniques != 0) childTechniques->runUpdated(runType, run);
}

void SharedRuns::setVisible(bool visible)
{
	if(child1 != 0) 
	{
		child1->setVisible(visible);
		child2->setVisible(visible);
		return;
	}

	setRenderablesVisible(visible);
}

void SharedRuns::hide()
{
	if(child1 != 0) 
	{
		child1->hide();
		child2->hide();
		return;
	}

	hideRenderables();
}

void SharedRuns::restoreVisibility()
{
	if(child1 != 0) 
	{
		child1->restoreVisibility();
		child2->restoreVisibility();
		return;
	}

	restoreRenderableVisibility();
}


